{ Composant TXHint version 1.0 (28/01/98)
  Par CRESTO Sylvain
  Copyright  1997 CRESTO Sylvain
  cresto@mygale.org
  http://www.mygale.org/~cresto/
  La Borde / 09230 Contrazy / France
    ----

  Composant pour Delphi 2.0, 3.0x et C++ Builder 1.0.

  Ce composant fais apparatre une bulle d'aide affichant le texte contenu dans un
  contrle Edit ou ComboBox lorsqu'il ne tient pas dans le contrle.
  Vous n'avez qu' placer ce composant sur votre fentre, et tous les composants
  Edit ou ComboBox de cette fiche dont la proprit ShowInt est mis  True
  auront cette caractristique. Rien de plus simple! :)

  Je travaille actuellement sur une version qui supporte les contrles ListBox, Treeview
  et Listview... passez sur mon site pour voir si elle est disponible si vous est intress!

  Remarque: Une fois ce composant plac sur votre feuille, vous ne devez plus utilisez
  l'vnement Application.OnShowHint, l'utiliser empcherez ce composant de fonctionner,
  utilisez  la place l'vnement OnShowHint de ce composant, qui remplis exactement la
  mme fonction.
    ----

  Ce composant est un FREEWARE, vous pouvez l'utiliser dans tous vos
  programmes (commerciaux ou pas !) et les distribuer sans rien me devoir.
  Vous utilisez ce composant  vos risques et prils.
  Par contre vous * NE DEVEZ PAS * distribuer le code source * MODIFI *
  de ce composant sans avoir eu au pralable mon accord.
                                                        Merci.



  -------------




  TXHint component version 1.0 (01/28/98)
  By CRESTO Sylvain
  Copyright  1997 CRESTO Sylvain
  cresto@mygale.org
  http://www.mygale.org/~cresto/
  La Borde / 09230 Contrazy / France
   ----

  Component for Delphi 2.0, 3.0x and C++ Builder 1.0.

  This component displays item of an Edit or ComboBox control as a hint when his length exceed
  the length of the control.
  You have only to place this component on a form, and all the Edit and ComboBox
  components of this window will have this function. Nothing simpler!

  I'm actualy working on a new version who support ListBox, Treeview and ListView controls...
  Download it on my homepage in a few weeks...

  Notice: You should not use the Application.OnShowHint event when using this component, use
  OnShowHint event of this component instead.
    ----

  This component is FREEWARE!
  No warranty is given by the author, expressed or implied.
  Do not distribute modified version without my agreement.
                                                       thanks.

}


unit xhint;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, DsgnIntf, StdCtrls;

type
  TOnShowHint = procedure (Sender: TObject; var HintStr: string; var CanShow: Boolean; var HintInfo: THintInfo) of object;
  TAboutProperty = class(TPropertyEditor)
  private
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;
  TXHint = class(TComponent)
  private
    FAbout:TAboutProperty;
    FActivate:Boolean;
    FOnShowHint:TOnShowHint;
    procedure DoShowHint(var HintStr: string; var CanShow: Boolean; var HintInfo: THintInfo);
    function MeasureText(Control:TWinControl;text:string;font:integer):integer;
    procedure SetActivate(value:boolean);
    procedure SetOnShowHint(value:TOnShowHint);
  public
    oldhinthidepause:integer;
    constructor Create(aOwner : TComponent); override;
  published
    property About : TAboutProperty read FAbout write FAbout;
    property Activate : Boolean read FActivate write SetActivate;
    property OnShowHint:TOnShowHint read FOnShowHint write SetOnShowHint;
  end;

procedure Register;

implementation

{$R XHINT.RES}

procedure Register;
begin
  RegisterComponents('CRESOFT', [TXHint]);
  RegisterPropertyEditor(TypeInfo(TAboutProperty), TXHint, 'ABOUT', TAboutProperty);
end;

{ TXHint }

constructor TXHint.create(aOwner : Tcomponent);
begin
  inherited create(aOwner);
  FActivate:=true;
  Application.OnShowHint:=DoShowHint;
  OldHinthidePause:=application.HinthidePause;
end;

procedure TXHint.SetActivate(value:boolean);
begin
  FActivate:=value;
end;

procedure TXHint.SetOnShowHint(value:TOnShowHint);
begin
  FOnShowHint:=value;
end;

function TXHint.MeasureText(Control:TWinControl;text:string;font:integer):integer;
  var P:^string;
      S:string;
      dc:hdc;
      rcText:TRect;
begin
  rctext:=rect(0,0,0,0);
  dc:=getwindowdc(control.handle);
  SelectObject(DC,font);
  S:=text+#0;
  P:=@S[1];
  DrawText(DC,PChar(P),-1,Rctext,DT_LEFT or DT_VCENTER or DT_SINGLELINE or DT_CALCRECT);
  MeasureText:=Rctext.Right+3-Rctext.Left;
end;

procedure TXHint.DoShowHint(var HintStr: string; var CanShow: Boolean; var HintInfo: THintInfo);
  var buttonwidth,fonthandle,maxwidth:integer;
      controltext:string;
begin
  if application.HinthidePause=-111 then application.HinthidePause:=OldHinthidePause;
  if Factivate then
  if (hintinfo.hintcontrol is tedit) or (hintinfo.hintcontrol is tcombobox) then
  begin
    if (hintinfo.hintcontrol is tedit) then
    with tedit(hintinfo.hintcontrol) do
    begin
      controltext:=text;
      buttonwidth:=0;
      fonthandle:=font.handle;
    end else
    with tcombobox(hintinfo.hintcontrol) do
    begin
      controltext:=text;
      if style<>csSimple then buttonwidth:=18 else buttonwidth:=0;
      fonthandle:=font.handle;
    end;
    if controltext<>'' then
    begin
      if measuretext(twincontrol(hintinfo.hintcontrol),controltext,fonthandle)>twincontrol(hintinfo.hintcontrol).clientwidth-buttonwidth then
      begin
        OldHinthidePause:=application.HinthidePause;
        application.HinthidePause:=-111;
        hintstr:=controltext;
        with hintinfo do
        begin
          maxwidth:=hintpos.x+twincontrol(hintinfo.hintcontrol).width;
          if hintpos.x+maxwidth+cursorrect.right<=screen.width then
          begin
            hintpos.x:=maxwidth;
            hintpos.y:=hintpos.y-27;
          end;
        end;
      end;
    end;
  end;
  If assigned(FOnShowHint) then FOnShowHint(self,HintStr,CanShow,HintInfo);
end;


{ TAboutProperty }

procedure TAboutProperty.Edit;
begin
  Application.MessageBox('By CRESTO Sylvain - 1997'#13'This component (for Delphi 1.0, 2.0, 3.0x and C++ '
    +'Builder 1.0) is FREEWARE.'#13#13'E-Mail : cresto@mygale.org'#13'WEB : http://www.mygale.org/~cresto/'
    +#13#13'Notice: You should not use the Application.OnShowHint event when using this component, use '
    +'OnShowHint event of this component instead.','XHint component version 1.0',MB_OK+ MB_ICONINFORMATION);
end;

function TAboutProperty.GetAttributes: TPropertyAttributes;
begin
  GetAttributes:=[paDialog, paReadOnly];
end;

function TAboutProperty.GetValue: string;
begin
  GetValue:='(About)';
end;

end.
